#! /usr/bin/env python
# -*- coding: utf-8 -*-

#	Copyright 2017, Marten de Vries
#
#	This file is part of OpenTeacher.
#
#	OpenTeacher is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	OpenTeacher is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with OpenTeacher.  If not, see <http://www.gnu.org/licenses/>.

import os
import json

class JavaScriptResolverModule:
	def __init__(self, moduleManager):
		self._mm = moduleManager

		self.type = "javaScriptResolver"

	def resolve(self, modName):
		try:
			with open(os.path.join('node_modules', modName, 'package.json')) as f:
				path = os.path.join('node_modules', modName, json.load(f)['main'])
		except (KeyError, FileNotFoundError):
			path = os.path.join('node_modules', modName, 'index.js')
		with open(path, encoding='UTF-8') as f:
			return path, f.read()

	def enable(self):
		self.active = True

	def disable(self):
		self.active = False

def init(moduleManager):
	return JavaScriptResolverModule(moduleManager)
